"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutomaticRefactoring = void 0;
// import { BigIfElseRefactorer } from './refactorers/bigIfElse.refactorer';
const project_service_1 = require("./services/project.service");
const uselessElse_refactorer_1 = require("./refactorers/uselessElse.refactorer");
const refactor_report_service_1 = require("./services/refactor-report.service");
const bigIfElse_refactorer_1 = require("./refactorers/bigIfElse.refactorer");
class AutomaticRefactoring {
    static setRefactorer(...refactorers) {
        this.refactorers = refactorers;
    }
    static start(astFolder) {
        this.setRefactorer(bigIfElse_refactorer_1.BigIfElseRefactorer, uselessElse_refactorer_1.UselessElseRefactorer);
        this.refactorFromSourceFile();
        new refactor_report_service_1.RefactorReportService(this.projectService.refactorProposals, astFolder).generateRefactorReport();
    }
    static refactorFromSourceFile() {
        this.refactorers.forEach((r) => {
            const REFACTORER = new r(this.projectService);
            REFACTORER.apply();
            this.projectService.addToRefactorProposals(REFACTORER.refactorProposals);
        });
    }
}
exports.AutomaticRefactoring = AutomaticRefactoring;
AutomaticRefactoring.projectService = new project_service_1.ProjectService('tsconfig.json');
