"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplexityService = void 0;
const init_generation_service_1 = require("../../languages-to-json-ast/init-generation.service");
const json_service_1 = require("../../languages-to-json-ast/json.service");
const json_ast_to_reports_1 = require("../../json-ast-to-reports/json-ast-to-reports");
class ComplexityService {
    /**
     * Get the cognitive complexity of the given source code
     * @param sourceCode
     * @returns {number}
     */
    static getCpxFromSourceCode(sourceCode) {
        const initGenerationService = new init_generation_service_1.InitGenerationService();
        const jsonAst = {
            astFolder: undefined
        };
        let astFolder = initGenerationService.generateAstFolderFromString(sourceCode).astFolder;
        astFolder = json_service_1.JsonService.astPropertyNames(astFolder);
        jsonAst.astFolder = astFolder;
        return json_ast_to_reports_1.JsonAstToReports.getTotalCpx(jsonAst);
    }
}
exports.ComplexityService = ComplexityService;
