"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RefactorerUtils = void 0;
const ts_morph_1 = require("ts-morph");
class RefactorerUtils {
    /**
     * Simple way to create method node
     * @param name the method name
     * @param block the method block node
     * @param parameters the method parameters
     * @returns {ts.MethodDeclaration}
     */
    static createSimpleMethod(name, block, parameters = []) {
        return ts_morph_1.ts.createMethod([], [], undefined, name, undefined, undefined, parameters, undefined, block);
    }
    /**
     * Simple way to create a parameter
     * @param identifier the parameter name
     * @param type the parameter type
     * @returns {ts.ParameterDeclaration}
     */
    static createSimpleParameter(identifier, type) {
        return ts_morph_1.ts.createParameter([], [], undefined, identifier, undefined, type);
    }
    /**
     * Simple way to create a method call
     * @param name the method to call name
     * @param parameters the passed parameters
     * @returns {ts.CallExpression}
     */
    static createMethodCall(name, parameters = []) {
        return ts_morph_1.ts.createCall(ts_morph_1.ts.createPropertyAccessChain(ts_morph_1.ts.createThis(), undefined, ts_morph_1.ts.createIdentifier(name)), [], parameters);
    }
}
exports.RefactorerUtils = RefactorerUtils;
