"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const cst_to_ast_1 = require("../cst-to-ast");
// @ts-ignore
function run(cstNode, children) {
    var _a, _b, _c, _d, _e;
    const arrayCreationExplicitInitSuffix = children.arrayCreationExplicitInitSuffix;
    const primitiveType = children.primitiveType;
    const classOrInterfaceType = children.classOrInterfaceType;
    const arrayCreationDefaultInitSuffix = children.arrayCreationDefaultInitSuffix;
    const classOrInterfaceTypeAst = [].concat(...(_a = classOrInterfaceType === null || classOrInterfaceType === void 0 ? void 0 : classOrInterfaceType.map(e => cst_to_ast_1.cstToAst(e))) !== null && _a !== void 0 ? _a : []);
    const arrayCreationDefaultInitSuffixAst = [].concat(...(_b = arrayCreationDefaultInitSuffix === null || arrayCreationDefaultInitSuffix === void 0 ? void 0 : arrayCreationDefaultInitSuffix.map(e => cst_to_ast_1.cstToAst(e))) !== null && _b !== void 0 ? _b : []);
    const primitiveTypeAst = [].concat(...(_c = primitiveType === null || primitiveType === void 0 ? void 0 : primitiveType.map(e => cst_to_ast_1.cstToAst(e))) !== null && _c !== void 0 ? _c : []);
    const dimExprs = (_d = arrayCreationDefaultInitSuffixAst === null || arrayCreationDefaultInitSuffixAst === void 0 ? void 0 : arrayCreationDefaultInitSuffixAst.find(e => e.kind === 'DimExprs')) === null || _d === void 0 ? void 0 : _d.children;
    return [
        ...[].concat(...(_e = arrayCreationExplicitInitSuffix === null || arrayCreationExplicitInitSuffix === void 0 ? void 0 : arrayCreationExplicitInitSuffix.map(e => cst_to_ast_1.cstToAst(e))) !== null && _e !== void 0 ? _e : []),
        createElementAccess([...classOrInterfaceTypeAst, ...primitiveTypeAst], dimExprs)
    ];
}
exports.run = run;
/**
 * Create Element Access Expression Ast Node
 * @param  {any} classOrInterfaceTypeAst
 * @param  {any} dimExprs
 * @returns any
 */
function createElementAccess(classOrInterfaceTypeAst, dimExprs) {
    var _a, _b, _c, _d, _e;
    if (!dimExprs)
        return undefined;
    if (dimExprs.length === 1) {
        return {
            kind: 'ElementAccessExpression',
            start: (_a = classOrInterfaceTypeAst[0]) === null || _a === void 0 ? void 0 : _a.start,
            end: (_b = dimExprs[0]) === null || _b === void 0 ? void 0 : _b.end,
            pos: (_c = classOrInterfaceTypeAst[0]) === null || _c === void 0 ? void 0 : _c.pos,
            children: [
                classOrInterfaceTypeAst.find(e => e.kind === 'Identifier'),
                dimExprs[0]
            ]
        };
    }
    else {
        const dimExpr = dimExprs.pop();
        return {
            kind: 'ElementAccessExpression',
            start: (_d = classOrInterfaceTypeAst[0]) === null || _d === void 0 ? void 0 : _d.start,
            pos: (_e = classOrInterfaceTypeAst[0]) === null || _e === void 0 ? void 0 : _e.pos,
            end: dimExpr === null || dimExpr === void 0 ? void 0 : dimExpr.end,
            children: [{
                    ...createElementAccess(classOrInterfaceTypeAst, dimExprs),
                }, dimExpr
            ]
        };
    }
}
