"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const cst_to_ast_1 = require("../cst-to-ast");
// @ts-ignore
function run(cstNode, children) {
    const expression = children.expression;
    return {
        kind: 'Keyword',
        start: cstNode.location.startOffset,
        end: cstNode.location.endOffset,
        pos: cstNode.location.startOffset,
        children: [
            ...generateAssertStatement(expression)
        ]
    };
}
exports.run = run;
/**
 * Generate Ast nodes for Assert Statement
 * @param  {Expression[]} expression
 * @returns any
 */
function generateAssertStatement(expression) {
    var _a, _b, _c, _d;
    const assertAst = [];
    if (Array.isArray(expression) && expression.length > 0) {
        assertAst.push({
            kind: 'IfStatement',
            start: expression[0].location.startOffset,
            end: expression[0].location.endOffset,
            pos: expression[0].location.startOffset,
            children: [
                ...[].concat(...(_b = (_a = [expression[0]]) === null || _a === void 0 ? void 0 : _a.map(e => cst_to_ast_1.cstToAst(e))) !== null && _b !== void 0 ? _b : [])
            ]
        });
        if (expression[1]) {
            assertAst.push({
                kind: 'ThrowStatement',
                start: expression[1].location.startOffset,
                end: expression[1].location.endOffset,
                pos: expression[1].location.startOffset,
                children: [
                    ...[].concat(...(_d = (_c = [expression[1]]) === null || _c === void 0 ? void 0 : _c.map(e => cst_to_ast_1.cstToAst(e))) !== null && _d !== void 0 ? _d : [])
                ]
            });
        }
    }
    return assertAst;
}
