"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const cst_to_ast_1 = require("../cst-to-ast");
function run(cstNode, children) {
    const constructorBody = children.constructorBody;
    const constructorDeclarator = children.constructorDeclarator;
    const constructorDeclaratorAst = [].concat(...constructorDeclarator.map(e => cst_to_ast_1.cstToAst(e)));
    const name = constructorDeclaratorAst.find(e => e.kind === 'Identifier').name;
    return {
        kind: 'Constructor',
        start: cstNode.location.startOffset,
        end: cstNode.location.endOffset,
        pos: cstNode.location.startOffset,
        name: name,
        children: [
            ...[].concat(...constructorDeclaratorAst.filter(e => e.kind === 'Parameter')),
            ...[].concat(...constructorBody.map(e => cst_to_ast_1.cstToAst(e))),
        ]
    };
}
exports.run = run;
