"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const cst_to_ast_1 = require("../cst-to-ast");
// @ts-ignore
function run(cstNode, children) {
    const unaryPrefixOperator = children.UnaryPrefixOperator;
    const primary = children.primary;
    if (unaryPrefixOperator) {
        const unaryPrefixOperatorAst = unaryPrefixOperator.map(e => cst_to_ast_1.cstToAst(e, 'unaryPrefixOperator'));
        return toUnaryPrefixOperator(unaryPrefixOperatorAst, primary.map(e => cst_to_ast_1.cstToAst(e)));
    }
    else {
        return [
            // ...unaryPrefixOperator?.map(e => cstToAst(e, 'unaryPrefixOperator')) ?? [],
            ...[].concat(...primary.map(e => cst_to_ast_1.cstToAst(e)))
        ];
    }
}
exports.run = run;
function toUnaryPrefixOperator(prefixes, primaries) {
    let res = undefined;
    let last = undefined;
    while (prefixes.length > 0) {
        const firstPrefix = prefixes.shift();
        if (!res) {
            last = firstPrefix;
            res = last;
        }
        else {
            last.children.push(firstPrefix);
            last = firstPrefix;
        }
    }
    last.children = [...[].concat(...primaries)];
    return res;
}
